#include "gen_defs.h"	/* This *must* be included before uifc.h or Bad Things happen */
#include "uifc.h"
#include "filepick.h"

int main(int argc, char **argv)
{
	uifcapi_t	uifc;
	struct file_pick	fp;
	int i;

	memset(&uifc, 0, sizeof(uifc));
	uifc.esc_delay=500;
	uifc.size=sizeof(uifc);
	if((i=uifcini32(&uifc))!=0) {
		printf("UIFC init returned an error (%d).\n",i);
		return(1);
	}
	uifc.scrn("File Picker Test");

	switch(filepick(&uifc, "Pick a file", &fp, ".", "*", UIFC_FP_ALLOWENTRY|UIFC_FP_OVERPROMPT|UIFC_FP_CREATPROMPT)) {
		case -1:
			printf("There was an error in the picker\n");
			return(1);
		case 0:
			printf("No files selected\n");
			filepick_free(&fp);
			return(0);
		case 1:
			printf("File is: %s\n",fp.selected[0]);
			filepick_free(&fp);
			return(0);
		default:
			printf("Multiple files selected:\n");
			for(i=0;i<fp.files;i++) {
				printf("%s\n",fp.selected[i]);
			}
			filepick_free(&fp);
			return(0);
	}
}
